/* sprite.h */

#ifndef __SPRITE_H__
#define __SPRITE_H__

#ifdef __cplusplus
extern "C" {
#endif

#include <SDL/SDL.h>
#include "defs.h"

typedef struct _sprite
{
	SDL_Surface *image;
	int alive;          //Zero = inactive, One or more = active.
	int x, y;           //location in screen (actually window).
	int step;           //positive or negative speed, currently only for aliens.
	int hits;           //Number of times hit, currently only for aliens.
} Sprite;

typedef enum {
	SPRITE_DRAW,        // Draw
	SPRITE_ERASE,       // Erase
	SPRITE_KILL,        // Kill, i.e set Sprite.alive to 0

	SPRITE_ACTIONS
} SpriteAction;

typedef void (*SpriteFunc)(Sprite *s);
SpriteFunc sprite_ops[SPRITE_ACTIONS];


extern int numupdates;

int  sprite_init(int number);
void sprite_free(void);

int  sprite_collide(Sprite *sprite1, Sprite *sprite2);

/* FIXME: These 2 functions need a new home */
void UpdateScreen(void);
void WaitFrame(void);

#ifdef __cplusplus
};
#endif

#endif
